# startapache.pl.  run from shell script startapache.
# start apache processes.
# For now, write to Perl 4.036 and up.

# Assumes first three fields of appropriate ps command are:
#    UID PID PPID

$APHOME=$ENV{'APHOME'};

#$BSD = -f '/vmunix';
#$pscmd = $BSD ? "ps -auxw" : "ps -ef";
$pscmd = "ps -ef";

$pidfile="$APHOME/rgw/apache/logs/httpd.pid";
$ntries = 5;
$rconf="$APHOME/rgw/apache/conf/redback.conf";
$portfree="$APHOME/bin/portfree";

# check if apache is already running.
if (-f $pidfile) {
   open(PIDFILE,$pidfile) || die "Can't open $pidfile: $!\n";
   $pidsched = <PIDFILE>;
   chop $pidsched;
   close(PIDFILE) || die "Can't close $pidfile: $!\n";

   open(PS,"$pscmd|") || die "$pscmd failed: $!\n";
   $title = <PS>;
   @pstab = <PS>;
   $schedidx = -1;
   foreach $i (0 .. $#pstab) {
      ($uname, $pid, $ppid) = split(' ',$pstab[$i]);
      if ($pid == $pidsched) {
         $schedidx = $i; last;
      }
   }
   if ($schedidx >= 0) {
      print "Scheduler is already running (pid=$pidsched).\n";
      exit 1;
   }
   unlink($pidfile);
}

# check if port is in use -- suggested by Nik Kesic
#if test -f "$APHOME/rgw/bin/portfree"; then
#   apacheport=`grep '^Port[ 	]' $APHOME/rgw/apache/conf/redback.conf | \
#   awk '{print $2}'`
#   if test -n "$apacheport"; then
#      if $APHOME/rgw/bin/portfree $apacheport; then
#         :
#      else
#         cat <<EOM
#WARNING! Apache port $apacheport is already in use.
#         Is there an old version of apache still running?
#         (Do a ps -ef|grep httpd to check)
#EOM
#      fi
#   fi
#fi
if (-f $portfree) {
   open(RCONF,$rconf) || die "Can't open $rconf: $!\n";
   $apacheport = 0;
   while (<RCONF>) {
      ($name, $val, $remainder) = split(' ', $_, 3);
      if ($name eq 'Port') {
         $apacheport = $val;
         last;
      }
   }
   close(RCONF);
   if ($apacheport > 0) {
      if (system("$portfree $apacheport") != 0) {
         print <<"EOM";
WARNING! Apache port $apacheport is already in use.
         Is there an old version of apache still running?
         (Do a ps -ef|grep httpd to check)
EOM
      }
   }
}

chdir "$APHOME/rgw/apache" || die "Can't cd to $APHOME/rgw/apache: $!\n";

# clean up apache's logs.
$errfile="$APHOME/rgw/apache/logs/error.log";
$accfile="$APHOME/rgw/apache/logs/access.log";
unlink($errfile); unlink($accfile);

$cmd="$APHOME/rgw/apache/httpd -f $rconf 2>$errfile";
print "Starting apache with $cmd.\n";
if (system($cmd) != 0) {
   print "apache failed.\n";
   open(ERRFILE,$errfile) || die "Can't open $errfile: $!\n";
   while (<ERRFILE>) {
      print;
   }
   close(ERRFILE);
   exit 1;
}

# wait for pid file to be created to confirm successful start
select(STDOUT);$|=1;
for ($z=1; $z <= $ntries; ++$z) {
   sleep $z;
   if (-f $pidfile) {
      open(PIDFILE,$pidfile) || die "Can't open $pidfile: $!\n";
      $pidsched = <PIDFILE>;
      chop $pidsched;
      close(PIDFILE) || die "Can't close $pidfile: $!\n";
      print "apache started successfully (pid=$pidsched).\n";
      print "(Use showapache to display processes).\n";
      exit 0;
   }
   print ".";
}

print "Sorry, apache has not started after $ntries seconds.\n";
open(ERRFILE,$errfile) || die "Can't open $errfile: $!\n";
while (<ERRFILE>) {
   print;
}
close(ERRFILE);
exit 1;
