# startrgw.pl.  run from shell script startrgw.
# start rgw processes.
# For now, write to Perl 4.036 and up.

# Assumes first three fields of appropriate ps command are:
#    UID PID PPID

$RGWHOME=$ENV{'RGWHOME'};

#$BSD = -f '/vmunix';
#$pscmd = $BSD ? "ps -auxw" : "ps -ef";
$pscmd = "ps -ef";

$pidfile="$RGWHOME/lock/RGWPID";
$logdir="$RGWHOME/log";
$ologdir="$RGWHOME/log.old";

umask(0);

if (-f $pidfile) {
   open(PIDFILE,$pidfile) || die "Can't open $pidfile: $!\n";
   $pidsched = <PIDFILE>;
   chop $pidsched;
   # strip trailing blanks
   $pidsched =~ s/ +//;
   close(PIDFILE) || die "Can't close $pidfile: $!\n";

   open(PS,"$pscmd|") || die "$pscmd failed: $!\n";
   $title = <PS>;
   @pstab = <PS>;
   $schedidx = -1;
   foreach $i (0 .. $#pstab) {
      ($uname, $pid, $ppid) = split(' ',$pstab[$i]);
      if ($pid == $pidsched) {
         $schedidx = $i; last;
      }
   }
   if ($schedidx >= 0) {
      print "Scheduler is already running (pid=$pidsched).\n";
      exit 1;
   } else {
      print "$pidfile exists, yet pid=$pidsched is not running!\n";
      print "deleting $pidfile.\n";
      unlink($pidfile);
   }
}

# clean up rgw's log too.
#$rgwtmp = "/tmp/rgw.tmp";
#if (open(RGWTMP,">$rgwtmp")) {
#   $date = `date`;
#   print RGWTMP "rgw log chopped at $date\n";
#   close(RGWTMP);
#   chmod 0666, $rgwtmp;
#}

# backup old log directory - thanks Nathan
if (-d $ologdir) {
   print "deleting files in $ologdir...\n";
   unlink <$ologdir/*>;
   rmdir($ologdir) || die "error removing $ologdir: $!\n";
}
rename($logdir,$ologdir) || die "error moving dir $logdir to $ologdir: $!\n";
mkdir($logdir,0777) || die "error creating $logdir dir: $!\n";

$cmd="$RGWHOME/bin/rgwsched";
if (system($cmd) == 0) {
   # give rgwsched time to get going so quick showrgw will be correct.
   sleep 2;
   print "$cmd started successfully.\n";
   print "(Use showrgw to display processes).\n";
} else {
   print "$cmd failed.\n";
   exit 1;
}

exit 0;
